package com.objis.demoejb3.mdb;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Statement;

import javax.activation.DataSource;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;

import domaine.DemandeFormation;

@MessageDriven(
		name = "DemandeFormationProcessor", 
		activationConfig={
				@ActivationConfigProperty(
						propertyName="destinationType",
						propertyValue="javax.jms.Queue"),
				@ActivationConfigProperty(
						propertyName="destinationName",
						propertyValue="jms/DemandeFormationQueue")
		}
	)
public class DemandeFormationManager implements MessageListener {

	@Resource
	private MessageDrivenContext context;
	
	private Connection connection ;
	
	private DataSource dataSource;
	
	@Resource(name="jdbc/ObjisFormations")
	public void setDataSource(DataSource dataSource) {
	this.dataSource = dataSource;
	}
	
	@Override
	public void onMessage(Message message) {
		// TODO grer le message rcupr dans la Queue (file de message)
		try {
			ObjectMessage objectMessage = (ObjectMessage) message;
			DemandeFormation demandeFormation = (DemandeFormation) objectMessage.getObject();
			gererDemandeFormation(demandeFormation);
		} catch (JMSException jmse) {
			jmse.printStackTrace();
			context.setRollbackOnly();
		} catch (SQLException sqle) {
			sqle.printStackTrace();
			context.setRollbackOnly();
		}
	}

	private void gererDemandeFormation(DemandeFormation demandeFormation)
	throws SQLException{
		
		 // TODO Traitement mtier : insrer en base de donnes la demande de formation 
		
		Statement statement = connection.createStatement();
		statement.execute(
		"INSERT INTO "
		+ "DEMANDE_FORMATION ("
		+ "NOM, "
		+ "SOCIETE, "
		+ "THEME, "
		+ "DATE ) "
		+ "VALUES ( "
		+ demandeFormation.getNomParticipant() + ", "
		+ "\' " + demandeFormation.getSocieteParticipant() + "\', "
		+ "\' " + demandeFormation.getThemeFormation() + "\', "
		+ demandeFormation.getDateDebut() + " )");
	}
	
/*	@PostConstruct
	public void initialize() {
	try {
	connection = (dataSource).getConnection();
	} catch (SQLException sqle) {
	sqle.printStackTrace();
	}
	}*/
	
	@PreDestroy
	public void cleanup() {
		try {
		connection.close();
		connection = null;
		} catch (SQLException sqle) {
		sqle.printStackTrace();
		}
		}
}
